$offlisting
$offsymxref
$offsymlist
$offuelxref
$offuellist
$offupper
sets
    i "motor domain" /1*20/
    k "platform domain" /1*3/
    i1(i) /1*5/
    i2(i) /6*10/
    i3(i) /11*15/
    i4(i) /16*20/
    kk "variable doamain" /1*6/
   ij /1*20/
;
alias(i,j); alias(i1,j1);alias(i2,j2);alias(i3,j3); alias(i4,j4);

;

parameters
  n              /10/
  lgap            /7.0e-1/
  poles          /2/
  m               /1/
  voltag         /115.0/
  resist        /1.69e-3/
  dcopper       /.896/
  dsteel        /.785/
  T(i)         /1 0.05,2 0.1, 3 0.125, 4 0.135, 5 0.15, 6 0.165, 7 0.175,8  0.2,9 0.225,10  0.25,11 0.275,12  0.3, 13 0.325, 14 0.35, 15 0.375, 16 0.4, 17 0.425, 18 0.45 , 19 0.475,20 0.5 /
  p           /300.0/
  maxh        /5000/
  minh       /3000/
  maxmass     /2.0/
  minmass     /0.2/
  mineta      /0.45/
  muo
  pi
  mur   / 1000/
  lmin /10/
  lmax /40/
  mro
  x(i,kk),xf(i,kk)
  torque
  landa(k,i)
  g(k,i)
  tlanda(k,i)
  Tlag(k),Tlo(k)
  alpha
  oldobj
  flower,final
  fval(ij)
* branchr(i) /1 2.12, 2 2.12, 3 2.12, 4 2.12, 5 2.12, 6 1, 7 1, 8 1, 9 1, 10 1, 11 1, 12 1, 13 1,14 1, 15 1/
* brancht(i) /1 0.1, 2 0.1, 3 0.1, 4 0.1, 5 0.1, 6 0.1, 7 0.1, 8 0.65, 9 0.65, 10 0.65/
* branchn /82.7/
*rbranch
*tbranch
;
*table xs(i,kk)
*     1        2       3        4          5         6
*1  0.276    2.184   0.803    2.999     703.851    83.071
*2  0.265    2.184   0.693    3.234     875.910    83.071
*3  0.276    2.184   0.645    3.296     916.906    83.071
*4  0.302    2.184   0.594    3.303     937.493    83.071
*5  0.351    2.184   0.533    3.311     981.651    83.071
*6  0.269    2.534   0.794    3.847    1142.346    82.448
*7  0.282    2.534   0.766    3.851    1155.396    82.448
*8  0.295    2.534   0.742    3.854    1168.826    82.448
*9  0.307    2.534   0.723    3.856    1182.311    82.448
*10 0.320    2.534   0.706    3.858    1195.663    82.448
*11 0.275    2.679   0.832    4.404    1247.324    76.172
*12 0.284    2.679   0.814    4.406    1258.058    76.172
*13 0.293    2.679   0.799    4.409    1268.752    76.172
*14 0.302    2.679   0.785    4.411    1279.334    76.172
*15 0.319    2.679   0.761    4.414    1299.995    76.172

;

scalar ii;
pi=2*arctan(inf); muo=4.0e-4*pi; mro=4.0e-4*pi;


positive variables

  awf      "cross-sectional area of the field wire [0.1,1.0]mm^2"
  radius   "radius of the motor [10,50]mm"
  thick    "thickness of the stator [1,10]mm"
  currnt   "current drawn (state variable) [1,6]amp"
  narm    "number of windings on the armature [100,1500]"
  nfield  "number of windings on the field [1,500]"
;


equations
maxm   "maximum mass of each motor"
minm   "maximum mass of each motor"
mineff "minimum efficiency of each motor"
maxeff
lo1
up1
lo2
up2
sat1   "maximum H"
sat2   "maximum H"
feas  "feasiblity constraint"
obj1  "objective function"
*bb1
*,bb2,
*bb3
;

free variables
conobj;

* variables bounds

awf.lo=0.1;        awf.up=1;
radius.lo=1;       radius.up=5;
thick.lo=0.1;      thick.up=1.;
currnt.lo=1.0;     currnt.up=6.0;
narm.lo=500;       narm.up=1500;
nfield.lo=50;      nfield.up=200;


sat1  ..   2.0*nfield*currnt/(5.1416*radius-0.4292*thick)=l=maxh/100;
sat2  ..   2.0*nfield*currnt/(5.1416*radius-0.4292*thick)=g=minh/100;


feas ..   radius=g=thick+200*lgap*0.001;

up2 ..    1.0e-3*lmax*currnt**2*narm*nfield=g=(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick)+torque*pi/mro+100*torque*pi*lgap/
          (muo*(radius-thick-0.1*lgap)));

lo2 ..    1.0e-3*lmin*currnt**2*narm*nfield=l=(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick)+torque*pi/mro+100*torque*pi*lgap/
          (muo*(radius-thick-0.1*lgap)));

lo1 ..    (voltag*currnt-p-2*currnt)*0.1-10*currnt**2*0.1/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
             /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/
             (currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick))=l=10*currnt**2*
             resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
             (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*
             (radius-thick-lgap*0.1));


up1 ..    (voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
             /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/
             (currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick))=g=10*currnt**2*
              resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
             (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*
             (radius-thick-lgap*0.1));



maxm .. (torque*pi**2*dsteel/currnt**2*(2*radius*thick-thick**2)*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +(torque*pi**2*dsteel/currnt**2*(radius-thick-lgap*0.1)**2*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +.02*dcopper/currnt**2*(narm*((1.0/((voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
       /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-
       0.1*lgap)))+0.04*(radius-thick)))*10*currnt**2*resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
       (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick-lgap*0.1))))*((torque*pi*
       (pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.02*(radius-thick-0.1*lgap)*narm*nfield*currnt**2)+nfield*
       awf*(2*(torque*pi*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.04*narm*nfield*currnt**2*(radius-thick)))
        =l=maxmass*narm*nfield;



minm .. (torque*pi**2*dsteel/currnt**2*(2*radius*thick-thick**2)*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +(torque*pi**2*dsteel/currnt**2*(radius-thick-lgap*0.1)**2*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +.02*dcopper/currnt**2*(narm*((1.0/((voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
       /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-
       0.1*lgap)))+0.04*(radius-thick)))*10*currnt**2*resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
       (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick-lgap*0.1))))*((torque*pi*
       (pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.02*(radius-thick-0.1*lgap)*narm*nfield*currnt**2)+nfield*
       awf*(2*(torque*pi*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.04*narm*nfield*currnt**2*(radius-thick)))
        =g=minmass*narm*nfield;


mineff .. p/(voltag * currnt)=g=mineta;
maxeff .. p/(voltag * currnt)=l=1.0;

*bb3 .. radius=g=rbranch;
*bb1 .. thick=g=tbranch;

obj1 ..   nfield.up*1.0e3*conobj=e=0.5*(nfield.up*1.0e3-nfield.up*1.0e3*p/(voltag*currnt))+0.5*(nfield.up*1.0e3/(maxmass*nfield*narm)*((torque*pi**2*dsteel/currnt**2*(radius**2
         +0.01*lgap**2+0.2*thick*lgap-0.2*radius*lgap)*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))+.02*dcopper/
         currnt**2*(narm*((1.0/((voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*
         narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick)))
         *10*currnt**2*resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*
         torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick-lgap*0.1))))*((torque*pi*(pi*(2*radius+thick)/(4*mro*
         thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.02*(radius-thick-0.1*lgap)*narm*nfield*currnt**2)+nfield*awf*(2*(torque*
         pi*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.04*narm*nfield*currnt**2*(radius-thick)))))
           +nfield.up*1.0e3*(thick*Tlag('1')/(thick.up-thick.lo)+radius*Tlag('2')/(radius.up-radius.lo)+nfield*Tlag('3')/(nfield.up-nfield.lo));


model motor /all/ ;

motor.optfile=1;
$onecho > baron.opt
    epsr 0.0001
    maxtime=1200000
    nlpsol=4
    nlpdolin=0
$offecho
option nlp=baron;

landa(k,i)=0.0; tlanda(k,i)=0.0; alpha=1.0;

oldobj=-100000;   ii=0; final= -1000;


loop(ij,
alpha=.08/(ii+1);

ii=ii+1;

flower=0.0;
loop (i,
*    awf.l=xs(i,'1');
*    radius.l=xs(i,'2');
*    thick.l=xs(i,'3');
*    currnt.l=xs(i,'4');
*    narm.l=xs(i,'5');
*    nfield.l=xs(i,'6');

    Tlag(k)=tlanda(k,i);
     torque=T(i);
*    rbranch=branchr(i);
*    tbranch=brancht(i);
    solve motor using nlp minimizing conobj;
    flower=flower+conobj.l;
    x(i,'1')=awf.l;
    x(i,'2')=radius.l;
    x(i,'3')=thick.l;
    x(i,'4')=currnt.l;
    x(i,'5')=narm.l;
    x(i,'6')=nfield.l;
);

fval(ij)=flower;

g('1',i1(i))=(x(i1,'3')-0.1*(sum(j1,x(j1,'3'))+sum(j2,x(j2,'3'))))/(thick.up-thick.lo);
g('1',i2(i))=(x(i2,'3')-0.1*(sum(j1,x(j1,'3'))+sum(j2,x(j2,'3'))))/(thick.up-thick.lo);

g('1',i3(i))=(x(i3,'3')-0.1*(sum(j3,x(j3,'3'))+sum(j4,x(j4,'3'))))/(thick.up-thick.lo);
g('1',i4(i))=(x(i4,'3')-0.1*(sum(j3,x(j3,'3'))+sum(j4,x(j4,'3'))))/(thick.up-thick.lo);

g('2',i1(i))=(x(i1,'2')-0.2*sum(j1,x(j1,'2')))/(radius.up-radius.lo);
g('2',i2(i))=(x(i2,'2')-0.2*sum(j2,x(j2,'2')))/(radius.up-radius.lo);

g('2',i3(i))=(x(i3,'2')-0.2*sum(j3,x(j3,'2')))/(radius.up-radius.lo);
g('2',i4(i))=(x(i4,'2')-0.2*sum(j4,x(j4,'2')))/(radius.up-radius.lo);

g('3',i1(i))=(x(i1,'6')-0.2*sum(j1,x(j1,'6')))/(nfield.up-nfield.lo);
g('3',i4(i))=(x(i4,'6')-0.2*sum(j4,x(j4,'6')))/(nfield.up-nfield.lo);


if (flower>final,
   final=flower;
   xf(i,kk)=x(i,kk)
);

oldobj=flower;

landa(k,i)=landa(k,i)+(alpha*g(k,i)/sqrt(power(g(k,i),2)))$(abs(g(k,i))>1.0e-4);

tlanda('1',i1(i))=landa('1',i1)-0.1*(sum(j1,landa('1',j1))+sum(j2,landa('1',j2)));
tlanda('1',i2(i))=landa('1',i2)-0.1*(sum(j1,landa('1',j1))+sum(j2,landa('1',j2)));

tlanda('1',i3(i))=landa('1',i3)-0.1*(sum(j3,landa('1',j3))+sum(j4,landa('1',j4)));
tlanda('1',i4(i))=landa('1',i4)-0.1*(sum(j3,landa('1',j3))+sum(j4,landa('1',j4)));

tlanda('2',i1(i))=landa('2',i1)-0.2*sum(j1,landa('2',j1));
tlanda('2',i2(i))=landa('2',i2)-0.2*sum(j2,landa('2',j2));
tlanda('2',i3(i))=landa('2',i3)-0.2*sum(j3,landa('2',j3));
tlanda('2',i4(i))=landa('2',i4)-0.2*sum(j4,landa('2',j4));


tlanda('3',i1(i))=landa('3',i1)-0.2*sum(j1,landa('3',j1));
tlanda('3',i4(i))=landa('3',i4)-0.2*sum(j4,landa('3',j4));


display x,landa,tlanda,g,flower;

);
options decimals=4.0
display final,xf,fval;