$offlisting
$offsymxref
$offsymlist
$offuelxref
$offuellist
$offupper

sets
       i "motor domain"  /1*20/
       k "platform domain" /1*4/
       kk "variable doamain" /t1*t6/
       ij /1*10/
   ;



parameters
  n              /10/
  lgap            /7.0e-1/
  poles          /2/
  m               /1/
  voltag         /115.0/
  resist        /1.69e-3/
  dcopper       /.896/
  dsteel        /.785/
  p           /300.0/
  maxh        /5000/
  minh       /3000/
  maxmass     /2.0/
  minmass     /0.2/
  mineta      /0.5/
  muo
  pi
  mur   / 1000/
  lmin /10/
  lmax /40/
  mro
  x(kk,i)
  torque
  landa1,landa2,landa3,landa4,landa5,landa6,landa7,landa8,landa9,landa10
  g1,g2,g3,g4,g5,g6,g7,g8,g9,g10
  tlanda
  Tlag
  alpha
  oldobj
  flower,final
  val(i)     / 1   10,  2    9,  3    3,  4   10,  5    1,  6    7,  7    6,  8    2,  9    4, 10    8,
              11  10, 12    5, 13    6, 14    8, 15    1, 16    8, 17    9, 18    2, 19    6, 20    7/
*              21   3, 22   10, 23    5, 24    2, 25    7, 26    1, 27    4, 28    9, 29    6, 30    8,
*              31   2, 32   10, 33    3, 34    4, 35    6, 36    9, 37    5, 38    8, 39    1, 40    7,
*              41   5, 42    2, 43    7, 44   10, 45    3, 46    8, 47    1, 48    4, 49    6, 50    9
*             /
;
table xs(kk,ij)
            1           2           3           4           5           6

t1       0.295       0.295       0.295       0.295       0.295       0.295
t2       1.762       2.041       2.217       2.346       2.446       2.526
t3       0.456       0.556       0.621       0.669       0.707       0.737
t4       2.966       3.151       3.322       3.492       3.668       3.853
t5     642.322     823.195     945.416    1037.608    1110.179    1168.496
t6      74.698      81.389      83.795      84.284      83.641      82.224

+           7           8           9          10

t1       0.295       0.295       0.295       0.295
t2       2.592       2.646       2.690       2.725
t3       0.762       0.782       0.798       0.811
t4       4.051       4.268       4.507       4.778
t5    1215.366    1252.544    1281.061    1303.512
t6      80.220      77.732      74.816      71.502




scalar ii;
pi=2*arctan(inf); muo=4.0e-4*pi; mro=4.0e-4*pi;


positive variables

  awf      "cross-sectional area of the field wire [0.1,1.0]mm^2"
  radius   "radius of the motor [10,50]mm"
  thick    "thickness of the stator [1,10]mm"
  currnt   "current drawn (state variable) [1,6]amp"
  narm    "number of windings on the armature [100,1500]"
  nfield  "number of windings on the field [1,500]"
;



equations
maxm   "maximum mass of each motor"
minm   "maximum mass of each motor"
mineff "minimum efficiency of each motor"
maxeff
lo1
up1
lo2
up2
sat1   "maximum H"
sat2   "maximum H"
feas  "feasiblity constraint"
obj1  "objective function"
;

free variables
conobj;

* variables bounds

awf.lo=0.1;        awf.up=1;
radius.lo=1;       radius.up=5;
thick.lo=0.1;      thick.up=1.0;
currnt.lo=1.0;     currnt.up=6.0;
narm.lo=200;       narm.up=1500;
nfield.lo=50;      nfield.up=150;


sat1  ..   2.0*nfield*currnt/(5.1416*radius-0.4292*thick)=l=maxh/100;
sat2  ..   2.0*nfield*currnt/(5.1416*radius-0.4292*thick)=g=minh/100;


feas ..   radius=g=thick+200*lgap*0.001;

up2 ..    1.0e-3*lmax*currnt**2*narm*nfield=g=(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick)+torque*pi/mro+100*torque*pi*lgap/
          (muo*(radius-thick-0.1*lgap)));

lo2 ..    1.0e-3*lmin*currnt**2*narm*nfield=l=(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick)+torque*pi/mro+100*torque*pi*lgap/
          (muo*(radius-thick-0.1*lgap)));

lo1 ..    (voltag*currnt-p-2*currnt)*0.1-10*currnt**2*0.1/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
             /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/
             (currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick))=l=10*currnt**2*
             resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
             (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*
             (radius-thick-lgap*0.1));


up1 ..    (voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
             /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/
             (currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick))=g=10*currnt**2*
              resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
             (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*
             (radius-thick-lgap*0.1));



maxm .. (torque*pi**2*dsteel/currnt**2*(2*radius*thick-thick**2)*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +(torque*pi**2*dsteel/currnt**2*(radius-thick-lgap*0.1)**2*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +.02*dcopper/currnt**2*(narm*((1.0/((voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
       /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-
       0.1*lgap)))+0.04*(radius-thick)))*10*currnt**2*resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
       (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick-lgap*0.1))))*((torque*pi*
       (pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.02*(radius-thick-0.1*lgap)*narm*nfield*currnt**2)+nfield*
       awf*(2*(torque*pi*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.04*narm*nfield*currnt**2*(radius-thick)))
        =l=maxmass*narm*nfield;



minm .. (torque*pi**2*dsteel/currnt**2*(2*radius*thick-thick**2)*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +(torque*pi**2*dsteel/currnt**2*(radius-thick-lgap*0.1)**2*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))
       +.02*dcopper/currnt**2*(narm*((1.0/((voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)
       /(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-
       0.1*lgap)))+0.04*(radius-thick)))*10*currnt**2*resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/
       (mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick-lgap*0.1))))*((torque*pi*
       (pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.02*(radius-thick-0.1*lgap)*narm*nfield*currnt**2)+nfield*
       awf*(2*(torque*pi*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.04*narm*nfield*currnt**2*(radius-thick)))
        =g=minmass*narm*nfield;


mineff .. p/(voltag * currnt)=g=mineta;
maxeff .. p/(voltag * currnt)=l=1.0;

obj1 ..   narm.up*conobj=e=0.5*(narm.up-narm.up*p/(voltag*currnt))+0.5*(narm.up/(maxmass*nfield*narm)*((torque*pi**2*dsteel/currnt**2*(radius**2
         +0.01*lgap**2+0.2*thick*lgap-0.2*radius*lgap)*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-lgap*0.1))))+.02*dcopper/
         currnt**2*(narm*((1.0/((voltag*currnt-p-2*currnt)-10*currnt**2/awf*2*resist*nfield*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*
         narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick)))
         *10*currnt**2*resist*narm*(2*(torque*pi*pi*(radius+0.5*thick)/(2*mro*thick*currnt**2*narm*nfield)+torque*pi/(mro*currnt**2*narm*nfield)+100*
         torque*pi*lgap/(currnt**2*narm*nfield*muo*(radius-thick-0.1*lgap)))+0.04*(radius-thick-lgap*0.1))))*((torque*pi*(pi*(2*radius+thick)/(4*mro*
         thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.02*(radius-thick-0.1*lgap)*narm*nfield*currnt**2)+nfield*awf*(2*(torque*
         pi*(pi*(2*radius+thick)/(4*mro*thick)+1/(mro)+100*lgap/(muo*(radius-thick-0.1*lgap))))+0.04*narm*nfield*currnt**2*(radius-thick)))))
        +narm.up*(Tlag*nfield/(nfield.up-nfield.lo));


model motor /all/ ;

motor.optfile=1;
$onecho > baron.opt
    epsr 0.000001
    maxtime=1200000
    nlpsol=4
    nlpdolin=0
$offecho
option nlp=baron;

landa1=0.0; landa2=0.0; landa3=0.0; landa4=0.0;landa5=0.0;landa6=0.0;landa7=0.0;landa8=0.0;landa9=0.0;landa10=0.0;
tlanda=0.0;

ii=0;

flower=0.0;
loop (i,
    alpha=1./(ii+15);
     if (mod(ii,10)=0,
        display flower;
        flower=0.0;
     );
     ii=ii+1;


     tlanda=(landa1)$(val(i)=1)+(landa2)$(val(i)=2)+(landa3)$(val(i)=3)+(landa4)$(val(i)=4)
     +(landa5)$(val(i)=5)+(landa6)$(val(i)=6)+(landa7)$(val(i)=7)+(landa8)$(val(i)=8)+(landa9)$(val(i)=9)+
     (landa10)$(val(i)=10)-0.1*(landa1+landa2+landa3+landa4+landa5+landa6+landa7+landa8+landa9+landa10);


     Tlag=tlanda;
     torque=val(i)*0.05;
 display torque,landa1,landa2,landa3,landa4,landa5,landa6,landa7,landa8,landa9,landa10,tlanda;

  awf.l=xs('t1','1')$(val(i)=1)+xs('t1','2')$(val(i)=2)+xs('t1','3')$(val(i)=3)+xs('t1','4')$(val(i)=4)+xs('t1','5')$(val(i)=5)
    +xs('t1','6')$(val(i)=6)+xs('t1','7')$(val(i)=7)+xs('t1','8')$(val(i)=8)+xs('t1','9')$(val(i)=9)+xs('t1','10')$(val(i)=10);
    radius.l=xs('t2','1')$(val(i)=1)+xs('t2','2')$(val(i)=2)+xs('t2','3')$(val(i)=3)+xs('t2','4')$(val(i)=4)+xs('t2','5')$(val(i)=5)
    +xs('t2','6')$(val(i)=6)+xs('t2','7')$(val(i)=7)+xs('t2','8')$(val(i)=8)+xs('t2','9')$(val(i)=9)+xs('t2','10')$(val(i)=10);
    thick.l=xs('t3','1')$(val(i)=1)+xs('t3','2')$(val(i)=2)+xs('t3','3')$(val(i)=3)+xs('t3','4')$(val(i)=4)+xs('t3','5')$(val(i)=5)
    +xs('t3','6')$(val(i)=6)+xs('t3','7')$(val(i)=7)+xs('t3','8')$(val(i)=8)+xs('t3','9')$(val(i)=9)+xs('t3','10')$(val(i)=10);
    currnt.l=xs('t4','1')$(val(i)=1)+xs('t4','2')$(val(i)=2)+xs('t4','3')$(val(i)=3)+xs('t4','4')$(val(i)=4)+xs('t4','5')$(val(i)=5)
    +xs('t4','6')$(val(i)=6)+xs('t4','7')$(val(i)=7)+xs('t4','8')$(val(i)=8)+xs('t4','9')$(val(i)=9)+xs('t4','10')$(val(i)=10);
    narm.l=xs('t5','1')$(val(i)=1)+xs('t5','2')$(val(i)=2)+xs('t5','3')$(val(i)=3)+xs('t5','4')$(val(i)=4)+xs('t5','5')$(val(i)=5)
    +xs('t5','6')$(val(i)=6)+xs('t5','7')$(val(i)=7)+xs('t5','8')$(val(i)=8)+xs('t5','9')$(val(i)=9)+xs('t5','10')$(val(i)=10);
    nfield.l=xs('t6','1')$(val(i)=1)+xs('t6','2')$(val(i)=2)+xs('t6','3')$(val(i)=3)+xs('t6','4')$(val(i)=4)+xs('t6','5')$(val(i)=5)
    +xs('t6','6')$(val(i)=6)+xs('t6','7')$(val(i)=7)+xs('t6','8')$(val(i)=8)+xs('t6','9')$(val(i)=9)+xs('t6','10')$(val(i)=10);

     solve motor using nlp minimizing conobj;

    x('t1',i)=awf.l;
    x('t2',i)=radius.l;
    x('t3',i)=thick.l;
    x('t4',i)=currnt.l;
    x('t5',i)=narm.l;
    x('t6',i)=nfield.l;


    flower=flower+conobj.l;
    g1=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 1)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=1);
    g2=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 2)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=2);
    g3=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 3)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=3);
    g4=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 4)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=4);
    g5=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 5)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=5);
    g6=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 6)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=6);
    g7=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 7)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=7);
    g8=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 8)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=8);
    g9=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 9)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=9);
   g10=(-0.1*nfield.l/(nfield.up-nfield.lo))$(val(i) ne 10)+(0.9*nfield.l/(nfield.up-nfield.lo))$(val(i)=10);

    landa1=landa1+alpha*g1;
    landa2=landa2+alpha*g2;
    landa3=landa3+alpha*g3;
    landa4=landa4+alpha*g4;
    landa5=landa5+alpha*g5;
    landa6=landa6+alpha*g6;
    landa7=landa7+alpha*g7;
    landa8=landa8+alpha*g8;
    landa9=landa9+alpha*g9;
    landa10=landa10+alpha*g10;


    );
display x;
display flower;


