$offlisting
$offsymxref
$offsymlist
$offuelxref

set   i  "motor domain" /1*10/
      i1(i) /1*3/
      i2(i) /8*10/
      i3(i) /4,5/
      i4(i) /6,7/

 k "variable domain" /1*6/

parameters
  lgap            /7.0e-1/
  poles          /2/
  m               /1/
  voltag         /115.0/
  resist        /1.69e-3/
  dcopper       /.896/
  dsteel        /.785/
  torque(i)     /1 0.05,2 0.1, 3 0.125, 4 0.15, 5 0.20, 6 0.25, 7 0.30, 8 0.35, 9 0.40, 10 0.50/
  p        /300.0/
  maxh        /5000/
  minh       /3000/
  maxmass     /2.0/
  minmass     /0.2/
  mineta      /0.5/
  muo
  pi
  mur   / 1000/
  lmin /10/
  lmax /40/
  mro
  ;
 scalar ii;
pi= 2*arctan(inf);   muo=4.0e-4*pi; mro=4.0e-4*pi;

positive variables

  awf(i)      "cross-sectional area of the field wire [0.1,1.0]mm^2"
  radius1,radius2   "radius of the motor [10,50]mm"
  thick1,thick2,thick3    "thickness of the stator [1,10]mm"
  currnt(i)   "current drawn (state variable) [1,6]amp"
  narm(i)    "number of windings on the armature [100,1500]"
  nfield(i)  "number of windings on the field [1,500]"

;

free variables
totobj "objective function"
;

equations
  maxm1(i1), maxm2(i2),maxm3(i3),maxm4(i4)  "maximum mass of each motor"
  minm1(i1), minm2(i2),minm3(i3),minm4(i4)  "maximum mass of each motor"
  mineff(i)"minimum efficiency of each motor"
  maxeff(i)
  lo11(i1), lo12(i2), lo13(i3), lo14(i4)
  up11(i1), up12(i2),up13(i3),up14(i4)
  lo21(i1), lo22(i2),lo23(i3),lo24(i4)
  up21(i1), up22(i2),up23(i3),up24(i4)
  sat11(i1),sat12(i2),sat13(i3),sat14(i4)   "maximum H"
  sat21(i1), sat22(i2),sat23(i3),sat24(i4)   "maximum H"
   feas1(i1),feas2(i2),feas3(i3),feas4(i4)  "feasiblity constraint"
   obj       "objective function"
;
* variables bounds

awf.lo(i)=0.1;      awf.up(i)=1.;
radius1.lo=1;       radius1.up=5.0;      radius2.lo=1;       radius2.up=5;
thick1.lo=0.1;  thick1.up=1.0;     thick2.lo=0.1;      thick2.up=1.0; thick3.lo=0.1; thick3.up=1.0;
currnt.lo(i)=1.0;   currnt.up(i)=6.0;
narm.lo(i)=200;     narm.up(i)=1500;
nfield.lo(i)=50;    nfield.up(i)=200;

awf.l(i)=0.295;
radius1.l=2.35;   radius2.l=2.60;
thick1.l=0.6;     thick2.l=0.8; thick3.l=0.7;
currnt.l('1')=2.966;    currnt.l('2')=3.151;  currnt.l('3')=3.237; currnt.l('4')=3.322;   currnt.l('5')=3.407;  currnt.l('6')=3.492;
narm.l('1')=642.327;    narm.l('2')=823.188;  narm.l('3')=889.123; narm.l('4')=945.431;   narm.l('5')=994.411;  narm.l('6')=1037.563;
nfield.l('1')=74.696;   nfield.l('2')=81.389;    nfield.l('3')=82.914;   nfield.l('4')=83.795;   nfield.l('5')=84.214;   nfield.l('6')=84.282;

*currnt.l('7')=3.579;    currnt.l('8')=3.668;   currnt.l('9')=3.759;  currnt.l('10')=3.853;  currnt.l('11')=3.950;   currnt.l('12')=4.049;
*narm.l('7')=1075.925;   narm.l('8')=1110.226;    narm.l('9')=1140.838;    narm.l('10')=1168.493;    narm.l('11')=1193.186;    narm.l('12')=1193.232;
*nfield.l('7')=84.075;   nfield.l('8')=83.639;    nfield.l('9')=83.014;   nfield.l('10')=82.224;  nfield.l('11')=81.287;   nfield.l('12')=80.265;

*currnt.l('13')=4.268;     currnt.l('14')=4.507;    currnt.l('15')=4.778;
*narm.l('13')=1252.571;    narm.l('14')=1281.060;    narm.l('15')=1301.327;
*nfield.l('13')=77.732;      nfield.l('14')=74.816;      nfield.l('15')=71.492;



*awf.l('1')= 0.295;     awf.l('2')=0.296 ;       awf.l('3')=0.395;     awf.l('4')=0.295;     awf.l('5')=0.296;
*thick1.l= 0.560;
*currnt.l('1')= 2.965;   currnt.l('2')=3.149 ;    currnt.l('3')=3.236;  currnt.l('4')=4.320;  currnt.l('5')=3.494;
*radius1.l=2.139;
*narm.l('1')=762   ;     narm.l('2')=824   ;      narm.l('3')=889  ;    narm.l('4')=945  ;    narm.l('5')=1037 ;
*nfield.l(i)=80;
*thick3.l=0.712;

*awf.l('6')=0.295;      awf.l('7')=0.296;       awf.l('8')=0.295;     awf.l('9')=0.296;     awf.l('10')=0.295;
*thick2.l=2.687;
*currnt.l('6')=3.664;    currnt.l('7')=3.842;     currnt.l('8')=3.759;  currnt.l('9')=3.786;  currnt.l('10')=3.804;
*radius2.l=4.055;
*narm.l('6')=1110 ;      narm.l('7')=1169 ;       narm.l('8')=1215 ;    narm.l('9')=1254 ;    narm.l('10')=1301 ;


sat11(i1(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius1-0.4292*thick1)=l=maxh/100;
sat21(i1(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius1-0.4292*thick1)=g=minh/100;

sat12(i2(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius2-0.4292*thick2)=l=maxh/100;
sat22(i2(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius2-0.4292*thick2)=g=minh/100;

sat13(i3(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius1-0.4292*thick3)=l=maxh/100;
sat23(i3(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius1-0.4292*thick3)=g=minh/100;

sat14(i4(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius2-0.4292*thick3)=l=maxh/100;
sat24(i4(i))  ..   2.0*nfield(i)*currnt(i)/(5.1416*radius2-0.4292*thick3)=g=minh/100;

**----------------------------
feas1(i1(i)) ..   radius1=g=thick1+200*lgap*0.001;
feas2(i2(i)) ..   radius2=g=thick2+200*lgap*0.001;
feas3(i3(i)) ..   radius1=g=thick3+200*lgap*0.001;
feas4(i4(i)) ..   radius2=g=thick3+200*lgap*0.001;
*---------------------------------
up21(i1(i)) ..  1.0e-3*lmax*currnt(i)**2*narm(i)*nfield(i)=g=(torque(i)*pi*pi*(radius1+
           0.5*thick1)/(2*mro*thick1)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius1-thick1-0.1*lgap)));
up22(i2(i)) ..  1.0e-3*lmax*currnt(i)**2*narm(i)*nfield(i)=g=(torque(i)*pi*pi*(radius2+
           0.5*thick2)/(2*mro*thick2)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius2-thick2-0.1*lgap)));
up23(i3(i)) ..  1.0e-3*lmax*currnt(i)**2*narm(i)*nfield(i)=g=(torque(i)*pi*pi*(radius1+
           0.5*thick3)/(2*mro*thick3)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius1-thick3-0.1*lgap)));
up24(i4(i)) ..  1.0e-3*lmax*currnt(i)**2*narm(i)*nfield(i)=g=(torque(i)*pi*pi*(radius2+
           0.5*thick3)/(2*mro*thick3)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius2-thick3-0.1*lgap)));
**--------------------------------------
lo21(i1(i)) ..  1.0e-3*lmin*currnt(i)**2*narm(i)*nfield(i)=l=(torque(i)*pi*pi*(radius1+
           0.5*thick1)/(2*mro*thick1)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius1-thick1-0.1*lgap)));
lo22(i2(i)) ..  1.0e-3*lmin*currnt(i)**2*narm(i)*nfield(i)=l=(torque(i)*pi*pi*(radius2+
           0.5*thick2)/(2*mro*thick2)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius2-thick2-0.1*lgap)));
lo23(i3(i)) ..  1.0e-3*lmin*currnt(i)**2*narm(i)*nfield(i)=l=(torque(i)*pi*pi*(radius1+
           0.5*thick3)/(2*mro*thick3)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius1-thick3-0.1*lgap)));
lo24(i4(i)) ..  1.0e-3*lmin*currnt(i)**2*narm(i)*nfield(i)=l=(torque(i)*pi*pi*(radius2+
           0.5*thick3)/(2*mro*thick3)+torque(i)*pi/mro+100*torque(i)*pi*lgap/(muo*(radius2-thick3-0.1*lgap)));
**-----------------------------
lo11(i1(i)) ..    (voltag*currnt(i)-p-2*currnt(i))*0.1-10*currnt(i)**2*0.1/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)
             /(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*(radius1-thick1))=l=10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)/(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*
             (radius1-thick1-lgap*0.1));
lo12(i2(i)) ..    (voltag*currnt(i)-p-2*currnt(i))*0.1-10*currnt(i)**2*0.1/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)
             /(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*(radius2-thick2))=l=10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)/(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*
             (radius2-thick2-lgap*0.1));
lo13(i3(i)) ..    (voltag*currnt(i)-p-2*currnt(i))*0.1-10*currnt(i)**2*0.1/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)
             /(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*(radius1-thick3))=l=10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*
             (radius1-thick3-lgap*0.1));
lo14(i4(i)) ..    (voltag*currnt(i)-p-2*currnt(i))*0.1-10*currnt(i)**2*0.1/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)
             /(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*(radius2-thick3))=l=10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*
             (radius2-thick3-lgap*0.1));
**------------------------------------------

up11(i1(i)) ..    (voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)
             /(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*(radius1-thick1))=g=10*currnt(i)**2*
              resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)/(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*
             (radius1-thick1-lgap*0.1));
up12(i2(i)) ..    (voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)
             /(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*(radius2-thick2))=g=10*currnt(i)**2*
              resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)/(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*
             (radius2-thick2-lgap*0.1));
up13(i3(i)) ..    (voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)
             /(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*(radius1-thick3))=g=10*currnt(i)**2*
              resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*
             (radius1-thick3-lgap*0.1));
up14(i4(i)) ..    (voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)
             /(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*(radius2-thick3))=g=10*currnt(i)**2*
              resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*
             (radius2-thick3-lgap*0.1));
**---------------------------------------------

maxm1(i1(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius1*thick1-thick1**2)*(pi*(2*radius1+thick1)/(4*mro*thick1)+
 1/(mro)+100*lgap/(muo*(radius1-thick1-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius1-thick1-lgap*0.1)**2*(pi*(2*radius1+thick1)/
(4*mro*thick1)+1/(mro)+100*lgap/(muo*(radius1-thick1-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)/(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*(radius1-thick1)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)/(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*
(radius1-thick1-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius1+thick1)/(4*mro*thick1)+1/(mro)
+100*lgap/(muo*(radius1-thick1-0.1*lgap))))+0.02*(radius1-thick1-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius1+thick1)/(4*mro*thick1)+1/(mro)+100*lgap/(muo*(radius1-thick1-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius1-
thick1))))=l=maxmass*narm(i)*nfield(i);

maxm2(i2(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius2*thick2-thick2**2)*(pi*(2*radius2+thick2)/(4*mro*thick2)+
 1/(mro)+100*lgap/(muo*(radius2-thick2-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius2-thick2-lgap*0.1)**2*(pi*(2*radius2+thick2)/
(4*mro*thick2)+1/(mro)+100*lgap/(muo*(radius2-thick2-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)/(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*(radius2-thick2)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)/(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*
(radius2-thick2-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius2+thick2)/(4*mro*thick2)+1/(mro)
+100*lgap/(muo*(radius2-thick2-0.1*lgap))))+0.02*(radius2-thick2-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius2+thick2)/(4*mro*thick2)+1/(mro)+100*lgap/(muo*(radius2-thick2-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius2-
thick2))))=l=maxmass*narm(i)*nfield(i);
maxm3(i3(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius1*thick3-thick3**2)*(pi*(2*radius1+thick3)/(4*mro*thick3)+
 1/(mro)+100*lgap/(muo*(radius1-thick3-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius1-thick3-lgap*0.1)**2*(pi*(2*radius1+thick3)/
(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius1-thick3-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*(radius1-thick3)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*
(radius1-thick3-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius1+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius1-thick3-0.1*lgap))))+0.02*(radius1-thick3-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius1+thick3)/(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius1-thick3-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius1-
thick3))))=l=maxmass*narm(i)*nfield(i);
maxm4(i4(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius2*thick3-thick3**2)*(pi*(2*radius2+thick3)/(4*mro*thick3)+
 1/(mro)+100*lgap/(muo*(radius2-thick3-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius2-thick3-lgap*0.1)**2*(pi*(2*radius2+thick3)/
(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius2-thick3-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*(radius2-thick3)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*
(radius2-thick3-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius2+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius2-thick3-0.1*lgap))))+0.02*(radius2-thick3-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius2+thick3)/(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius2-thick3-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius2-
thick3))))=l=maxmass*narm(i)*nfield(i);
**----------------------------------------------------------------
minm1(i1(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius1*thick1-thick1**2)*(pi*(2*radius1+thick1)/(4*mro*thick1)+
 1/(mro)+100*lgap/(muo*(radius1-thick1-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius1-thick1-lgap*0.1)**2*(pi*(2*radius1+thick1)/
(4*mro*thick1)+1/(mro)+100*lgap/(muo*(radius1-thick1-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)/(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*(radius1-thick1)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)/(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*
(radius1-thick1-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius1+thick1)/(4*mro*thick1)+1/(mro)
+100*lgap/(muo*(radius1-thick1-0.1*lgap))))+0.02*(radius1-thick1-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius1+thick1)/(4*mro*thick1)+1/(mro)+100*lgap/(muo*(radius1-thick1-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius1-
thick1))))=g=minmass*narm(i)*nfield(i);

minm2(i2(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius2*thick2-thick2**2)*(pi*(2*radius2+thick2)/(4*mro*thick2)+
 1/(mro)+100*lgap/(muo*(radius2-thick2-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius2-thick2-lgap*0.1)**2*(pi*(2*radius2+thick2)/
(4*mro*thick2)+1/(mro)+100*lgap/(muo*(radius2-thick2-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)/(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*(radius2-thick2)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)/(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*
(radius2-thick2-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius2+thick2)/(4*mro*thick2)+1/(mro)
+100*lgap/(muo*(radius2-thick2-0.1*lgap))))+0.02*(radius2-thick2-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius2+thick2)/(4*mro*thick2)+1/(mro)+100*lgap/(muo*(radius2-thick2-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius2-
thick2))))=g=minmass*narm(i)*nfield(i);
minm3(i3(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius1*thick3-thick3**2)*(pi*(2*radius1+thick3)/(4*mro*thick3)+
 1/(mro)+100*lgap/(muo*(radius1-thick3-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius1-thick3-lgap*0.1)**2*(pi*(2*radius1+thick3)/
(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius1-thick3-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*(radius1-thick3)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*
(radius1-thick3-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius1+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius1-thick3-0.1*lgap))))+0.02*(radius1-thick3-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius1+thick3)/(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius1-thick3-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius1-
thick3))))=g=minmass*narm(i)*nfield(i);
minm4(i4(i)) ..
 ((torque(i)*pi**2*dsteel/currnt(i)**2*(2*radius2*thick3-thick3**2)*(pi*(2*radius2+thick3)/(4*mro*thick3)+
 1/(mro)+100*lgap/(muo*(radius2-thick3-lgap*0.1))))+(torque(i)*pi**2*dsteel/currnt(i)**2*(radius2-thick3-lgap*0.1)**2*(pi*(2*radius2+thick3)/
(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius2-thick3-lgap*0.1))))+.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))
 -10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*
currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*(radius2-thick3)))*10*currnt(i)**2*
resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*
(radius2-thick3-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius2+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius2-thick3-0.1*lgap))))+0.02*(radius2-thick3-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius2+thick3)/(4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius2-thick3-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius2-
thick3))))=g=minmass*narm(i)*nfield(i);
**--------------------------

mineff(i) .. p/(voltag * currnt(i))=g=mineta;

maxeff(i) .. p/(voltag * currnt(i))=l=1.0;
**-------------------

obj ..   narm.up('1')*totobj=e=sum(i1(i),0.45*(narm.up(i)-p*narm.up(i)/(voltag * currnt(i)))+0.55*(narm.up(i)/
         (maxmass*nfield(i)*narm(i))*((torque(i)*pi**2*dsteel/currnt(i)**2*(radius1**2+0.01*lgap**2+0.2*thick1*lgap-0.2*radius1*lgap)*(pi*(2*radius1+thick1)/
         (4*mro*thick1)+1/(mro)+100*lgap/(muo*(radius1-thick1-lgap*0.1))))

  +.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)
             /(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*(radius1-thick1)))*10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick1)/(2*mro*thick1*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick1-0.1*lgap)))+0.04*
             (radius1-thick1-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius1+thick1)/(4*mro*thick1)+1/(mro)
+100*lgap/(muo*(radius1-thick1-0.1*lgap))))+0.02*(radius1-thick1-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius1+thick1)/(4*mro*thick1)+1/(mro)
+100*lgap/(muo*(radius1-thick1-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius1-thick1))))))


+sum(i2(i),0.45*(narm.up(i)-p*narm.up(i)/(voltag * currnt(i)))+0.55*(narm.up(i)/
         (maxmass*nfield(i)*narm(i))*((torque(i)*pi**2*dsteel/currnt(i)**2*(radius2**2+0.01*lgap**2+0.2*thick2*lgap-0.2*radius2*lgap)*(pi*(2*radius2+thick2)/
         (4*mro*thick2)+1/(mro)+100*lgap/(muo*(radius2-thick2-lgap*0.1))))

  +.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)
             /(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*(radius2-thick2)))*10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick2)/(2*mro*thick2*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick2-0.1*lgap)))+0.04*
             (radius2-thick2-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius2+thick2)/(4*mro*thick2)+1/(mro)
+100*lgap/(muo*(radius2-thick2-0.1*lgap))))+0.02*(radius2-thick2-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius2+thick2)/(4*mro*thick2)+1/(mro)
+100*lgap/(muo*(radius2-thick2-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius2-thick2))))))
+sum(i3(i),0.45*(narm.up(i)-p*narm.up(i)/(voltag * currnt(i)))+0.55*(narm.up(i)/
         (maxmass*nfield(i)*narm(i))*((torque(i)*pi**2*dsteel/currnt(i)**2*(radius1**2+0.01*lgap**2+0.2*thick3*lgap-0.2*radius1*lgap)*(pi*(2*radius1+thick3)/
         (4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius1-thick3-lgap*0.1))))

  +.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)
             /(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*(radius1-thick3)))*10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius1+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius1-thick3-0.1*lgap)))+0.04*
             (radius1-thick3-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius1+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius1-thick3-0.1*lgap))))+0.02*(radius1-thick3-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius1+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius1-thick3-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius1-thick3))))))
+sum(i4(i),0.45*(narm.up(i)-p*narm.up(i)/(voltag * currnt(i)))+0.55*(narm.up(i)/
         (maxmass*nfield(i)*narm(i))*((torque(i)*pi**2*dsteel/currnt(i)**2*(radius2**2+0.01*lgap**2+0.2*thick3*lgap-0.2*radius2*lgap)*(pi*(2*radius2+thick3)/
         (4*mro*thick3)+1/(mro)+100*lgap/(muo*(radius2-thick3-lgap*0.1))))

  +.02*dcopper/currnt(i)**2*(narm(i)*((1.0/((voltag*currnt(i)-p-2*currnt(i))-10*currnt(i)**2/awf(i)*2*resist*nfield(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)
             /(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/(mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/
             (currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*(radius2-thick3)))*10*currnt(i)**2*
             resist*narm(i)*(2*(torque(i)*pi*pi*(radius2+0.5*thick3)/(2*mro*thick3*currnt(i)**2*narm(i)*nfield(i))+torque(i)*pi/
             (mro*currnt(i)**2*narm(i)*nfield(i))+100*torque(i)*pi*lgap/(currnt(i)**2*narm(i)*nfield(i)*muo*(radius2-thick3-0.1*lgap)))+0.04*
             (radius2-thick3-lgap*0.1))))*((torque(i)*pi*(pi*(2*radius2+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius2-thick3-0.1*lgap))))+0.02*(radius2-thick3-0.1*lgap)*narm(i)*nfield(i)*currnt(i)**2)+nfield(i)*awf(i)*(2*(torque(i)*
pi*(pi*(2*radius2+thick3)/(4*mro*thick3)+1/(mro)
+100*lgap/(muo*(radius2-thick3-0.1*lgap))))+0.04*narm(i)*nfield(i)*currnt(i)**2*(radius2-thick3))))));

model motor /all/ ;
motor.optfile=1;
$onecho > baron.opt
epsr 0.000001
maxtime=1200000
nlpsol=4
nlpdolin=0
$offecho
option nlp=conopt;
solve motor using nlp minimizing totobj;

option decimals=8;
display totobj.l;