sets
   o    orders /0*4/,
   i  " performance domain"   /wcap, aratio,nsize, parea, tgap /


parameters
* Marketing parameters
   Q    total market size /5/
   ap2  a2 polynomial coefficient for price part-worth       /-0.0017143/
   ap1  a1 polynomial coefficient for price part-worth       /-0.013509/
   ap0  a0 polynomial coefficient for price part-worth       / 1.0374/
   ev0  outside good (no-choice option) =exp(v0)                /1/
   cv   "variable cost"     /3/
   cf   "fixed cost"        /1/

   Minpoly(i)  /wcap -0.535,aratio -.47,parea -.13,tgap -.398,nsize -0.755/
   Maxpoly(i)  /wcap  0.241,aratio  .305,parea .1,tgap  0.256,nsize 0.386/
   Minp       /-0.92/
   Maxp       /0.75/
* Engineering Parameters
    y1  "Gap between Base and Cover"                           /0.30  /
    y2  "Horizontal Distance between Spring and Pivot"         /1.10  /
    y3  "Aspect Ratio of Number (Length/Width)"                /1.29  /
    y6  "Maximum spring deflection"                            /.5  /
    y7  "Minimum distance of the supports from the centerline" /4.00  /
    y8  "Number of lbs that Number Length Spans"               /16.00 /
    y11 "Distance between top of the cover and window"         /1.13  /
    y12 "Length of Tick Mark+Gap to Number"                    /0.31  /
    y13 "Minimum vertical distance between supports"           /6.0/
    x5min   "Lower bound for x5"                               /0.125/
    x5max   "upper bound for x5"                               /12.0/
    x14min  "lower bound for x14"                              /8.5/
    x14max  "upper bound for x14"                              /14.0/
    x7      "variable x7 is fixed in this model"               /0.5/
    x10     "variable x10 is fixed in this model"              /0.5/
    x11     "variable x11 is fixed in this model"              /1.9/
    Minz(i)     /wcap 2.0,aratio 0.75,parea 1.0,tgap 0.63, nsize 0.75/
    Maxz(i)     /wcap 4.0,aratio 1.33,parea 1.4,tgap 1.875,nsize 1.75/
    pi
 ;
scalars
*output
weight, ratio, number, gap, area;

pi= 2*arctan(inf);

table a(i,o) polynomial fitting coefficients
         4                3            2            1            0
wcap     0          0.423844581   -4.286609981   14.144898    -15.067124
aratio 34.8044        -132.2115     177.9438     -99.4869      19.2282
parea  200.8852367  -992.4232052  1827.581129  -1486.439334  450.4112036
tgap   3.938036738  -20.37017339  37.03985793  -27.24144964  6.563132511
nsize   0            0.868461568  -4.69621128  8.592920728  -4.923720258
;


positive variables
  x1      " Length from Base to Force on Long Lever"
  x2      " Length from Force to Spring on Long Lever"
  x3      " Length from Base to Force on Short Lever"
  x4      " Length from Force to Joint on Short Lever "
  x6      "spring constant"
  x8      " Length of Rack "
  x9      " pitch diameter of the pinion"
  x12     " Dial Diameter "
  x13     " Cover Length "
  p        "price"
;

free variable
  profit " objective function"
;

* upper and lower bounds for variables
p.lo=10;       p.up=30;
x1.lo=0.125;   x1.up=12;
x2.lo=0.125;   x2.up=15;
x3.lo=0.125;   x3.up=12;
x4.lo=0.125;   x4.up=12;
x6.lo=10.0;    x6.up=100;
x8.lo=2.00;    x8.up=10;
x9.lo=0.25;    x9.up=3.0;
x12.lo=4.0;    x12.up=12;
x13.lo=8.5;    x13.up=14;
*profit.lo=Minpoly('wcap')+Minpoly('nsize')+Minpoly('aratio')+Minpoly('tgap');
*profit.up=Maxpoly('wcap')+Maxpoly('nsize')+Maxpoly('aratio')+Maxpoly('tgap');

x1.l=1.845  ;
x2.l=9.814  ;
x3.l=0.824  ;
x4.l=4.720  ;
x6.l=20.0   ;
x8.l=4.273  ;
x9.l=0.250  ;
x12.l=9.547  ;
x13.l=11.747 ;

equations
*marketing constraints
  fobj
  poly1lo, poly1up
  poly2lo, poly2up
  poly3lo, poly3up
  poly4lo, poly4up
  poly5lo, poly5up
  pricelo, priceup
*engineering constraints
  x5lo,x5up            "bounds on x5"
  x14lo,x14up          "bounds on x14"
  wPerf1, wPerf2       "weight capacity bounds"
  arPerf1,arPerf2      "aspect ratio bounds"
  nsPerf1,nsPerf2      "number size bounds"
  paPerf1,paPerf2      "platform area bounds"
  tgPerf1,tgPerf2      "tickmark gap bounds"
  cst1,cst2            "Dial should be small enough to fit in the scale"
  cst3,cst4            "Long levers must fit in the scale"
  cst5                 "Joint position of the long and shorts levers"
  cst6,cst16           "scale stablity constraint"
  cst11,cst12          "Rack must fit inside the scale"
  cst13                "spring deflection"
  cst14,cst15          "dial should not interfere with supports on levers"
;

* joint position of short and long levers
cst5 .. x1*x4=l=x2*x3;
* bounds on x5
x5lo .. x1*x4=g=x3*x5min;
x5up .. x1*x4=l=x3*x5max;
* bounds on x14
x14lo .. 2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1=g=x14min;
x14up .. 2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1=l=x14max;
* weight capacity bounds
wPerf1  .. Maxz('wcap')=g=0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1);
wPerf2  .. Minz('wcap')=l=0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1);
*aspect ratio bounds
arPerf1 .. Maxz('aratio')*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)=g=x13;
arPerf2 .. Minz('aratio')*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)=l=x13;
*number size bounds
nsPerf1 .. Maxz('nsize')=g=2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3));
nsPerf2 .. Minz('nsize')=l=2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3));
*platform area bounds
paPerf1 .. 100*Maxz('parea')=g= x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1);
paPerf2 .. 100*Minz('parea')=l= x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1);
*tickmark gap bounds
tgPerf1 .. Maxz('tgap')=g= x12*x11*x1/(.2*x6*x9*x10*(x1+x2));
tgPerf2 .. Minz('tgap')=l= x12*x11*x1/(.2*x6*x9*x10*(x1+x2));
* dial should fit within the scale
cst1 .. x12=l=2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2));
cst2 .. x12=l=x13-2*y1-x7-y2;
* long levers should fit within the scale
cst3 .. x1+x2=l=sqrt(power(x13-2*y1-x7,2)+(x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2));
cst4 .. x1+x2=g=sqrt(power(x13-2*y1-x7,2)+((x1+x2)*y7/x2)**2);
* scale stability
cst6 .. (x2*x3-x1*x4)/(x3*(x1+x2))*sqrt((x1+x2)**2-power(x13-2*y1-x7,2))+x4*sqrt(1-power(((x2-x1*x4/x3)/(x1+x2)*(x13-2*y1-x7)+x7)/(x3+x4),2))=g=y7;
cst16 .. (x13-2*y1)*(x1+x2)*(x3+x4)-x3*(x1+x2)*(x13-2*y1-x7)-x3*x7*(x1+x2)=g=y13*(x1+x2)*(x3+x4);
* rack must fit within the scale
cst11 .. x8+x7+y2+x11=l=x13-2*y1;
cst12..  x8=g=x13-2*y1-.5*x12-x7-y2-x10;
* spring deflection
cst13.. y6=g=2*pi*x9*x10/x11;
* dial should not intefere with support positions on levers
cst14.. 0.5*x12=l=sqrt(power(x13-2*y1-.5*x12-x7,2)+x2**2-2*(x13-2*y1-.5*x12-x7)*x2*(x13-2*y1-x7)/(x1+x2));
cst15.. 0.5*x12=l=sqrt(power((x2-x1*x4/x3)/(x1+x2)*sqrt((x1+x2)**2-power(x13-2*y1-x7,2))+x4*sqrt(1-power((((x2-x1*x4/x3)/(x1
        +x2)*(x13-2*y1-x7)+x7)/(x3+x4)),2)),2)+power(x13-2*y1-0.5*x12-x3*(((x2-x1*x4/x3)/(x1+x2)*(x13-2*y1-x7)+x7)/(x3+x4)),2));

*bounds on 4th order interpolating polynomials
* 1-weight capapcity
poly1lo .. a('wcap','4')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),4)
           +a('wcap','3')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),3)
           +a('wcap','2')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),2)
           +a('wcap','1')*(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1))
           +a('wcap','0')=g=Minpoly('wcap');
poly1up .. a('wcap','4')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),4)
           +a('wcap','3')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),3)
           +a('wcap','2')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),2)
           +a('wcap','1')*(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1))
           +a('wcap','0')=l=Maxpoly('wcap');
* 2-aspect ratio
poly2lo .. a('aratio','4')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),4)
          +a('aratio','3')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),3)
          +a('aratio','2')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),2)
           +a('aratio','1')*(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
          +a('aratio','0')=g=Minpoly('aratio');
poly2up .. a('aratio','4')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),4)
          +a('aratio','3')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),3)
          +a('aratio','2')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),2)
          +a('aratio','1')*(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
          +a('aratio','0')=l=Maxpoly('aratio');
* 3- platform area
poly3lo .. a('parea','4')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),4)
          +a('parea','3')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),3)
          +a('parea','2')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),2)
          +a('parea','1')*0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
          +a('parea','0')=g=Minpoly('parea');
poly3up .. a('parea','4')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),4)
          +a('parea','3')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),3)
          +a('parea','2')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),2)
          +a('parea','1')*0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
          +a('parea','0')=l=Maxpoly('parea');
* 4- tickmark gap
poly4lo .. a('tgap','4')*power(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)),4)
          +a('tgap','3')*power(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)),3)
          +a('tgap','2')*power(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)),2)
          +a('tgap','1')*(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)))
          +a('tgap','0')=g=Minpoly('tgap');
poly4up .. a('tgap','4')*power(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)),4)
          +a('tgap','3')*power(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)),3)
          +a('tgap','2')*power(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)),2)
          +a('tgap','1')*(x12*x11*x1/(.2*x6*x9*x10*(x1+x2)))
          +a('tgap','0')=l=Maxpoly('tgap');
* 5- number size
poly5lo ..
a('nsize','4')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),4)
           +a('nsize','3')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),3)
           +a('nsize','2')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),2)
           +a('nsize','1')*(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)))
           +a('nsize','0')=g=Minpoly('nsize');
poly5up ..
a('nsize','4')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),4)
           +a('nsize','3')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),3)
           +a('nsize','2')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),2)
           +a('nsize','1')*(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)))
           +a('nsize','0')=l=Maxpoly('nsize');

pricelo  ..  ap2*sqr(p)+ap1*p+ap0=g=Minp;
priceup  ..  ap2*sqr(p)+ap1*p+ap0=l=Maxp;

fobj .. profit=e=Q*(exp(a('wcap','4')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),4)
           +a('wcap','3')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),3)
           +a('wcap','2')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),2)
           +a('wcap','1')*(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1))
           +a('wcap','0')
           +a('aratio','4')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
           x1*x4)/(x1*(x3+x4)),2))+2*y1),4)
           +a('aratio','3')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
           x1*x4)/(x1*(x3+x4)),2))+2*y1),3)
           +a('aratio','2')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
           x1*x4)/(x1*(x3+x4)),2))+2*y1),2)
           +a('aratio','1')*(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
           x1*x4)/(x1*(x3+x4)),2))+2*y1))
           +a('aratio','0')
*           +a('parea','4')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*           (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),4)
*           +a('parea','3')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*           (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),3)
*           +a('parea','2')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*           (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),2)
*           +a('parea','1')*0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*           (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
*           +a('parea','0')
*           +a('tgap','4')*(5*x12*x11*x1/(x6*x9*x10*(x1+x2)))**4
           +a('tgap','3')*power(10*pi*x12*x11*x1/(2*pi*x6*x9*x10*(x1+x2)),3)
           +a('tgap','2')*power(10*pi*x12*x11*x1/(2*pi*x6*x9*x10*(x1+x2)),2)
           +a('tgap','1')*10*pi*x12*x11*x1/(2*pi*x6*x9*x10*(x1+x2))
           +a('tgap','0')
           +a('nsize','4')*power(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)),4)
           +a('nsize','3')*power(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)),3)
           +a('nsize','2')*power(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)),2)
           +a('nsize','1')*(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
           +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)))
           +a('nsize','0')
           +ap2*sqr(p)+ap1*p+ap0)/
           (ev0+exp(a('wcap','4')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),4)
           +a('wcap','3')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),3)
           +a('wcap','2')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),2)
           +a('wcap','1')*(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1))
           +a('wcap','0')
           +a('aratio','4')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
              x1*x4)/(x1*(x3+x4)),2))+2*y1),4)
          +a('aratio','3')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
              x1*x4)/(x1*(x3+x4)),2))+2*y1),3)
          +a('aratio','2')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
              x1*x4)/(x1*(x3+x4)),2))+2*y1),2)
           +a('aratio','1')*(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-
              x1*x4)/(x1*(x3+x4)),2))+2*y1))
          +a('aratio','0')
*           +a('parea','4')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*           (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),4)
*          +a('parea','3')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*          (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),3)
*         +a('parea','2')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*          (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),2)
*          +a('parea','1')*0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*
*          (x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
*          +a('parea','0')
*           +a('tgap','4')*power(10*pi*x12*x11*x1/(2*pi*x6*x9*x10*(x1+x2)),4)
           +a('tgap','3')*power(10*pi*x12*x11*x1/(2*pi*x6*x9*x10*(x1+x2)),3)
           +a('tgap','2')*power(10*pi*x12*x11*x1/(2*pi*x6*x9*x10*(x1+x2)),2)
           +a('tgap','1')*10*pi*x12*x11*x1/(2*pi*x6*x9*x10*(x1+x2))
           +a('tgap','0')
+a('nsize','4')*power(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)),4)
           +a('nsize','3')*power(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)),3)
           +a('nsize','2')*power(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)),2)
           +a('nsize','1')*(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))
             +(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)))
           +a('nsize','0')
            +ap2*sqr(p)+ap1*p+ap0)))*(p-cv)-cf;
$ontext

fobj .. profit=e=
a('wcap','4')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),4)
           +a('wcap','3')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),3)
           +a('wcap','2')*power((0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)),2)
           +a('wcap','1')*(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1))
           +a('wcap','0')
           +a('aratio','4')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),4)
           +a('aratio','3')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),3)
           +a('aratio','2')*power(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1),2)
           +a('aratio','1')*(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
           +a('aratio','0')
*           +a('parea','4')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),4)
*           +a('parea','3')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),3)
*           +a('parea','2')*power(0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)),2)
*           +a('parea','1')*0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))
*           +a('parea','0')
           +a('tgap','4')*power(x12*x11*x1/(0.2*x6*x9*x10*(x1+x2)),4)
           +a('tgap','3')*power(x12*x11*x1/(0.2*x6*x9*x10*(x1+x2)),3)
           +a('tgap','2')*power(x12*x11*x1/(0.2*x6*x9*x10*(x1+x2)),2)
           +a('tgap','1')*(x12*x11*x1/(0.2*x6*x9*x10*(x1+x2)))
           +a('tgap','0')
           +a('nsize','4')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),4)
           +a('nsize','3')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),3)
           +a('nsize','2')*power(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)),2)
           +a('nsize','1')*(2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)))
           +a('nsize','0');
*           +ap2*sqr(p)+ap1*p+ap0;
$offtext

model weightscale /all/;
option nlp=baron;
weightscale.optfile=1;
$onecho > baron.opt
    epsr 0.1
    maxtime=1200000
    nlpsol=4
    pfreq=200
$offecho

solve weightscale using nlp maximizing profit;

weight=2*pi*x6.l*x9.l*x10*(x1.l+x2.l)/(x11*x1.l);
ratio=x13.l/(2*sqrt((x3.l*(x1.l+x2.l)/x1.l)**2-power(x7+(x13.l-2*y1)*(x2.l*x3.l-x1.l*x4.l)/(x1.l*(x3.l+x4.l)),2))+2*y1);
number=2*((y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))+(y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))**3/3)*(.5*x12.l-y12)
             /(1.0+2.0/y3*((y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))+(y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))**3/3));
area=x13.l*(2*sqrt((x3.l*(x1.l+x2.l)/x1.l)**2-power(x7+(x13.l-2*y1)*(x2.l*x3.l-x1.l*x4.l)/(x1.l*(x3.l+x4.l)),2))+2*y1);
gap=x12.l*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l));

display weight, ratio, number, area, gap, p.l;