sets
   o    orders /0*4/,
   i  " performance domain"   /wcap, aratio,nsize, tgap /
   ii "loop counter for updating multipliers" /1*30/;


parameters
* Marketing parameters
   Q    total market size /5/
   ap2  a2 polynomial coefficient for price part-worth       /-0.0017143/
   ap1  a1 polynomial coefficient for price part-worth       /-0.013509/
   ap0  a0 polynomial coefficient for price part-worth       / 1.0374/
   ev0  outside good (no-choice option) =exp(v0)                /1/
*   Minpoly(i)  /wcap -0.535,aratio -.47,parea -.13,tgap -.398,nsize -0.755/
*   Maxpoly(i)  /wcap  0.241,aratio  .305,parea .1,tgap  0.256,nsize 0.386/
*root node
*   Minpoly(i)  /wcap -0.535,aratio -.47,tgap -.398,nsize -0.755/
* first branch
*   Minpoly(i)  /wcap -0.13,aratio -.47,tgap -.398,nsize -0.755/
* second branch
*   Minpoly(i)  /wcap -0.13,aratio -.059,tgap -.398,nsize -0.755/
* 3rd branch
   Minpoly(i)  /wcap  0.126,aratio -.059,tgap -.398,nsize -0.755/
   Maxpoly(i)  /wcap  0.241,aratio  .305,tgap  0.256,nsize 0.386/

   Minp       /-0.92/
   Maxp       /0.75/
   cv   "variable cost"     /3/
   cf   "fixed cost"        /1/
* Engineering Parameters
    y1  "Gap between Base and Cover"                           /0.30  /
    y2  "Horizontal Distance between Spring and Pivot"         /1.10  /
    y3  "Aspect Ratio of Number (Length/Width)"                /1.29  /
    y6  "Maximum spring deflection"                            /.5  /
    y7  "Minimum distance of the supports from the centerline" /4.00  /
    y8  "Number of lbs that Number Length Spans"               /16.00 /
    y11 "Distance between top of the cover and window"         /1.13  /
    y12 "Length of Tick Mark+Gap to Number"                    /0.31  /
    y13 "Minimum vertical distance between supports"           /6.0/
    x5min   "Lower bound for x5"                               /0.125/
    x5max   "upper bound for x5"                               /12.0/
    x14min  "lower bound for x14"                              /8.5/
    x14max  "upper bound for x14"                              /14.0/
    x7      "variable x7 is fixed in this model"               /0.5/
    x10     "variable x10 is fixed in this model"              /0.5/
    x11     "variable x11 is fixed in this model"              /1.9/
*    Minz(i)     /wcap 2.0,aratio 0.75,parea 1.0,tgap 0.63, nsize 0.75/
*    Maxz(i)     /wcap 4.0,aratio 1.33,parea 1.4,tgap 1.875,nsize 1.75/
* root note
*    Minz(i)     /wcap 2.,aratio 0.75,tgap 0.63, nsize 0.75/
* first branch & 2nd
*    Minz(i)     /wcap 2.367,aratio 0.75,tgap 0.63, nsize 0.75/
* third branch
   Minz(i)     /wcap 2.50,aratio 0.75,tgap 0.63, nsize 0.75/
* second branch  & third
*   Maxz(i)     /wcap 4.,aratio 1.0745,tgap 1.875,nsize 1.75/
* 4th branch
   Maxz(i)     /wcap 4.,aratio 1.04,tgap 1.875,nsize 1.75/
*root node and first branch
*    Maxz(i)     /wcap 4.,aratio 1.33,tgap 1.875,nsize 1.75/

    landa(i) "lagrange mutipliers"
    TotObj(ii)   "lagrangian upper bound"
    alpha    "step size for subgradient method"
    pi
    zE(i)    "attribute values in engineering model"
    zs(i)
    xs1,xs2,xs3,xs4,xs6,xs8,xs9,xs12,xs13
 ;

pi= 2*arctan(inf);

table a(i,o) polynomial fitting coefficients
         4                3            2            1            0
wcap     0          0.423844581   -4.286609981   14.144898    -15.067124
aratio 34.8044        -132.2115     177.9438     -99.4869      19.2282
*parea  200.8852367  -992.4232052  1827.581129  -1486.439334  450.4112036
tgap   3.938036738  -20.37017339  37.03985793  -27.24144964  6.563132511
nsize   0            0.868461568  -4.69621128  8.592920728  -4.923720258
;


positive variables
*engineering variables
  x1      " Length from Base to Force on Long Lever"
  x2      " Length from Force to Spring on Long Lever"
  x3      " Length from Base to Force on Short Lever"
  x4      " Length from Force to Joint on Short Lever "
  x6      "spring constant"
  x8      " Length of Rack "
  x9      " pitch diameter of the pinion"
  x12     " Dial Diameter "
  x13     " Cover Length "
*marketing variables
  p        "price"
  z(i)    "marketing attributes"
;

free variable
  objM " marketing objective function"
  objE "Engineering objective function"
;

* upper and lower bounds for variables
p.lo=10;       p.up=30;
z.lo(i)=Minz(i);   z.up(i)=Maxz(i);

x1.lo=0.125;   x1.up=12;
x2.lo=0.125;   x2.up=12;
x3.lo=0.125;   x3.up=12;
x4.lo=0.125;   x4.up=12;
x6.lo=10.0;    x6.up=200;
x8.lo=2.00;    x8.up=10;
x9.lo=0.25;    x9.up=3.0;
x12.lo=4.0;    x12.up=12;
x13.lo=8.0;    x13.up=14;

xs1=1.845  ;
xs2=9.814  ;
xs3=0.824  ;
xs4=4.720  ;
xs6=20.0   ;
xs8=4.273  ;
xs9=0.250  ;
xs12=9.547  ;
xs13=11.747 ;

zs('wcap')=2.88;
zs('aratio')=0.95;
zs('nsize')=1.75;
zs('tgap')=1.3;
*zs('parea')=1.25;

equations
  MktObj   "marketing objective function"
  EngObj   "engineering objective function"
*marketing constraints
  polylo(i), polyup(i)
  pricelo,   priceup
*engineering constraints
  x5lo,x5up            "bounds on x5"
  x14lo,x14up          "bounds on x14"
  wPerf1, wPerf2       "weight capacity bounds"
  arPerf1,arPerf2      "aspect ratio bounds"
  nsPerf1,nsPerf2      "number size bounds"
  paPerf1,paPerf2      "platform area bounds"
  tgPerf1,tgPerf2      "tickmark gap bounds"
  cst1,cst2            "Dial should be small enough to fit in the scale"
  cst3,cst4            "Long levers must fit in the scale"
  cst5                 "Joint position of the long and shorts levers"
  cst6,cst16           "scale stablity constraint"
  cst11,cst12          "Rack must fit inside the scale"
  cst13                "spring deflection"
  cst14,cst15          "dial should not interfere with supports on levers"
;

* joint position of short and long levers
cst5 .. x1*x4=l=x2*x3;
* bounds on x5
x5lo .. x1*x4=g=x3*x5min;
x5up .. x1*x4=l=x3*x5max;
* bounds on x14
x14lo .. 2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1=g=x14min;
x14up .. 2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1=l=x14max;
* weight capacity bounds
wPerf1  .. Maxz('wcap')=g=0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1);
wPerf2  .. Minz('wcap')=l=0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1);
*aspect ratio bounds
arPerf1 .. Maxz('aratio')*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)=g=x13;
arPerf2 .. Minz('aratio')*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1)=l=x13;
*number size bounds
nsPerf1 .. Maxz('nsize')=g=2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3));
nsPerf2 .. Minz('nsize')=l=2*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
             /(1.0+2.0/y3*((y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))+(y8*x11*x1/(2.0*x6*x9*x10*(x1+x2)))**3/3));
*platform area bounds
*paPerf1 .. 100*Maxz('parea')=g= x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1);
*paPerf2 .. 100*Minz('parea')=l= x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1);

paPerf1 .. 140=g= x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1);
paPerf2 .. 100=l= x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1);

*tickmark gap bounds
tgPerf1 .. Maxz('tgap')=g= x12*x11*x1/(.2*x6*x9*x10*(x1+x2));
tgPerf2 .. Minz('tgap')=l= x12*x11*x1/(.2*x6*x9*x10*(x1+x2));
* dial should fit within the scale
cst1 .. x12=l=2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2));
cst2 .. x12=l=x13-2*y1-x7-y2;
* long levers should fit within the scale
cst3 .. x1+x2=l=sqrt(power(x13-2*y1-x7,2)+(x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2));
cst4 .. x1+x2=g=sqrt(power(x13-2*y1-x7,2)+((x1+x2)*y7/x2)**2);
* scale stability
cst6 .. (x2*x3-x1*x4)/(x3*(x1+x2))*sqrt((x1+x2)**2-power(x13-2*y1-x7,2))+x4*sqrt(1-power(((x2-x1*x4/x3)/(x1+x2)*(x13-2*y1-x7)+x7)/(x3+x4),2))=g=y7;
cst16 .. (x13-2*y1)*(x1+x2)*(x3+x4)-x3*(x1+x2)*(x13-2*y1-x7)-x3*x7*(x1+x2)=g=y13*(x1+x2)*(x3+x4);
* rack must fit within the scale
cst11 .. x8+x7+y2+x11=l=x13-2*y1;
cst12..  x8=g=x13-2*y1-.5*x12-x7-y2-x10;
* spring deflection
cst13.. y6=g=2*pi*x9*x10/x11;
* dial should not intefere with support positions on levers
cst14.. 0.5*x12=l=sqrt(power(x13-2*y1-.5*x12-x7,2)+x2**2-2*(x13-2*y1-.5*x12-x7)*x2*(x13-2*y1-x7)/(x1+x2));
cst15.. 0.5*x12=l=sqrt(power((x2-x1*x4/x3)/(x1+x2)*sqrt((x1+x2)**2-power(x13-2*y1-x7,2))+x4*sqrt(1-power((((x2-x1*x4/x3)/(x1
        +x2)*(x13-2*y1-x7)+x7)/(x3+x4)),2)),2)+power(x13-2*y1-0.5*x12-x3*(((x2-x1*x4/x3)/(x1+x2)*(x13-2*y1-x7)+x7)/(x3+x4)),2));
*bounds on 4th order interpolating polynomials
polylo(i) .. a(i,'4')*z(i)**4+a(i,'3')*z(i)**3+a(i,'2')*z(i)**2+a(i,'1')*z(i)+a(i,'0')=g=Minpoly(i);
polyup(i) .. a(i,'4')*z(i)**4+a(i,'3')*z(i)**3+a(i,'2')*z(i)**2+a(i,'1')*z(i)+a(i,'0')=l=Maxpoly(i);
*bounds on price
pricelo  ..  ap2*sqr(p)+ap1*p+ap0=g=Minp;
priceup  ..  ap2*sqr(p)+ap1*p+ap0=l=Maxp;
*marketing objective function
MktObj ..  objM=e=Q*(exp(sum(i,a(i,'4')*z(i)**4+a(i,'3')*z(i)**3+a(i,'2')*z(i)**2+a(i,'1')*z(i)+a(i,'0'))+ap2*sqr(p)+ap1*p+ap0)
           /(ev0+exp(sum(i,a(i,'4')*z(i)**4+a(i,'3')*z(i)**3+a(i,'2')*z(i)**2+a(i,'1')*z(i)+a(i,'0'))+ap2*sqr(p)+ap1*p+ap0)))
           *(p-cv)-cf-sum(i,landa(i)*z(i)/(Maxz(i)-Minz(i)));
*engineering objective function
EngObj ..  objE=e=landa('wcap')*(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1))/(Maxz('wcap')-Minz('wcap'))
           +landa('aratio')*(x13/(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))/(Maxz('aratio')-Minz('aratio'))
           +landa('tgap')*(5*x12*x11*x1/(x6*x9*x10*(x1+x2)))/(Maxz('tgap')-Minz('tgap'))
           +landa('nsize')*(2*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))+(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)*(.5*x12-y12)
           /(1.0+2.0/y3*((pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))+(pi*y8*x11*x1/(2.0*pi*x6*x9*x10*(x1+x2)))**3/3)))/(Maxz('nsize')-Minz('nsize')) ;
*           +landa('parea')*0.01*(x13*(2*sqrt((x3*(x1+x2)/x1)**2-power(x7+(x13-2*y1)*(x2*x3-x1*x4)/(x1*(x3+x4)),2))+2*y1))/(Maxz('parea')-Minz('parea'))


model EngOpt /x5lo,x5up,x14lo,x14up,wPerf1, wPerf2,arPerf1,arPerf2,nsPerf1,nsPerf2,paPerf1,paPerf2,tgPerf1,tgPerf2,
               cst1,cst2,cst3,cst4,cst5,cst6,cst16,cst11,cst12,cst13,cst14,cst15,EngObj/;
model MktOpt /polylo,polyup,pricelo,priceup,MktObj/;

option nlp=conopt;
option minlp=baron;
EngOpt.optfile=1;
MktOpt.optfile=1;

$onecho > baron.opt
    epsr 0.02
    maxtime=1200000
    nlpsol=4
    pfreq=200
$offecho
landa(i)=0.0;

loop (ii,
   alpha=30./(0.1*ord(ii)+1);
   x1.l=xs1 ;
   x2.l=xs2  ;
   x3.l=xs3  ;
   x4.l=xs4  ;
   x6.l=xs6   ;
   x8.l=xs8  ;
   x9.l=xs9  ;
   x12.l=xs12  ;
   x13.l=xs13 ;

   z.l(i)=zs(i)
   solve MktOpt using nlp maximizing objM;
*   landa(i)=landa(i)+alpha*z.l(i)/(Maxz(i)-Minz(i));
   solve EngOpt using minlp maximizing objE;
   TotObj(ii)=objM.l+objE.l;
   zE('wcap')=0.02*pi*x6.l*x9.l*x10*(x1.l+x2.l)/(x11*x1.l);
   zE('aratio')=x13.l/(2*sqrt((x3.l*(x1.l+x2.l)/x1.l)**2-power(x7+(x13.l-2*y1)*(x2.l*x3.l-x1.l*x4.l)/(x1.l*(x3.l+x4.l)),2))+2*y1);
   zE('nsize')=2*((y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))+(y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))**3/3)*(.5*x12.l-y12)
             /(1.0+2.0/y3*((y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))+(y8*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l)))**3/3));
*   zE('parea')=0.01*x13.l*(2*sqrt((x3.l*(x1.l+x2.l)/x1.l)**2-power(x7+(x13.l-2*y1)*(x2.l*x3.l-x1.l*x4.l)/(x1.l*(x3.l+x4.l)),2))+2*y1);
   zE('tgap')=10*x12.l*x11*x1.l/(2.0*x6.l*x9.l*x10*(x1.l+x2.l));
*   landa(i)=landa(i)-alpha*zE(i)/(Maxz(i)-Minz(i));

   landa(i)=landa(i)-alpha*(zE(i)-z.l(i))/(Maxz(i)-Minz(i));

   display z.l,zE,landa,TotObj;

);

display zE,z.l, p.l, TotObj;