sets
  atb  marketing attributes  /z1*z5,p/
* z1:weight capapcity, z2: aspect ratio z3:platform area z4:gap size  z5:number size
  i linear segments set /1*4/
  ns market segments   /1*7/
  ii loop counter for updating multipliers /1*40/
  alias(i,j);
  set ij(j,i) /1.2,2.3,3.4/
  at(atb) /z1*z5/;
parameters
*marketing parameters
  Q     market size    /5/
  s(ns) segment size  /1 0.07108,2 0.19222,3 0.14155,4  0.1983,5  0.13579,6  0.15783,7 0.10323/
  cv    unit variable cost     /3/
  cI    fixed investment cost /3/
  MinzE(atb) product attributes lower bounds    /z1 2.0,z2 0.75,z3 1.0,z4 0.63, z5 0.75/
  MaxzE(atb) product attributes upper bounds    /z1 4.0,z2 1.33,z3 1.4,z4 1.875,z5 1.75/
  x(atb)
* Engineering Parameters
   y1  "Gap between Base and Cover"                            /0.30  /
   y2  "Horizontal Distance between Spring and Pivot"         /1.10  /
   y3  "Aspect Ratio of Number (Length/Width)"                /1.29  /
   y5  "Minimum Distance from centerline to short lever"      /2.00  /
   y6  "Maximum spring deflection"                            /0.50  /
   y7  "Minimum distance of the supports from the centerline" /4.00  /
   y8  "Number of lbs that Number Length Spans"               /16.00 /
   y11 "Distance between top of the cover and window"         /1.13  /
   y12 "Length of Tick Mark+Gap to Number"                    /0.31  /
   y13 "minimum vertical"                                     /8.0/
   x6                                                         /50.0/
   x7                                                         /0.5/
   x10     "variable x10 is fixed in this model"              /0.5/
   x11     "variable x11 is fixed in this model"              /1.9/
   x5min   "Lower bound for x5"                               /0.125/
   x5max   "upper bound for x5"                               /12.0/
*decomposition parameters
 landa(at)  lagrange multipliers for product attributes
 alpha       step size in the subgradient update
 totobj(ii)  overall objective: profit
 zE(at), zM(atb)
 xs1,xs2,xs3,xs4,xs8,xs12,xs13,xs14
;

table   minz(ns,atb)    lower bounds on piecewise linear functions
       z1          z2           z3            z4            z5         p
1    -1.336    -1.33897668    -0.862        -1.564        -0.959     -1.353
2    -0.595    -1.73097148    -0.451        -0.549        -1.201     -0.857
3    -0.383    -0.56298397    -0.267        -3.493        -0.730     -0.788
4    -0.338    -0.08298485     0.283         0.1780       -0.354     -0.202
5    -0.916     0.08699499     0.051         0.0043       -0.398     -2.969
6    -0.696    -0.88698575    -0.869        -0.390        -1.243     -3.015
7    -1.192    -1.4           -0.487        -0.28474      -1.133     -0.809
table   maxz(ns,atb)    upper bounds on piecewise linear functions
       z1           z2           z3           z4            z5        p
1     0.063    0.3827625989    0.011         0.37         0.116     0.465
2     0.206    0.7874813619    0.104         0.222        0.470     0.131
3     0.198    0.2007195960    0.194         1.557        0.247     0.428
4     0.703    0.5544923990    0.498         0.663        0.814     0.699
5     0.566    0.5085769471    0.452         0.320        0.600     3.192
6     0.036    0.2861482715    0.449         0.147        0.483     1.644
7     0.553    0.56765840998   0.250        -0.059        0.461     0.236

table   f0(ns,atb)
      z1           z2         z3         z4        z5       p
1   -1.336      -0.785       0.011     -1.564    -0.959   0.465
2   -0.595        0.2       -0.451     -0.549    -1.201   0.131
3   -0.383      -0.042       0.194     -3.493    -0.73    0.428
4   -0.338       0.444       0.357      0.178    -0.354   0.699
5   -0.916       0.098       0.168      0.320    -0.398   3.192
6   -0.696      -0.177       0.449     -0.39     -1.243   1.644
7   -1.192      -1.400      -0.450     -0.059    -1.133   0.236
table delx(atb,i)
       1           2            3            4
z1    0.25       0.25         0.25         0.25
z2    0.25       0.25         0.25         0.25
z3  0.224138   0.206896    0.24137931    0.32758621
z4    0.25       0.25         0.25         0.25
z5    0.25       0.25         0.25         0.25
p     0.25       0.25         0.25         0.25

table dely(ns,atb,i)
         1                  2                 3                 4
1.z1    0.975             0.424            -0.276             0.084
1.z2   0.857597         0.3101699          -0.4711556       -1.2505836
1.z3   -0.053            -0.365             -0.268            -0.1870
1.z4   0.673708         0.8242924           0.24496103       0.19103897
1.z5   0.524             0.551              -0.419              -0.091
1.p    -0.545           -0.135              -0.578              -0.56
2.z1   0.486             0.315              -0.152             -0.201
2.z2   0.504397         0.0830843         -0.856943116       -1.6615097
2.z3   0.238            0.1810               0.1360           -0.104
2.z4   0.337973         0.4330270         -0.24110069       -0.00989931
2.z5   0.688            0.851               -0.023             0.155
2.p   -0.001           -0.109              -0.0380            -0.84
3.z1   0.412            0.054              -0.219              0.334
3.z2  0.1961517         0.04656789       -0.08090479        -0.682798775
3.z3  -0.211            0.021             -0.127              -0.144
3.z4  2.838293          1.57470654        0.55812907        0.078870929
3.z5  0.555             0.4220             -0.03700            0.03
3.p   -0.023           -0.3750           -0.315              -0.503
4.z1  0.673             0.365             0.003              -0.195
4.z2  0.0564455         0.05404685       -0.012705005      -0.624772247
4.z3  -0.074            0.2150           -0.04               -0.146
4.z4   0.20747          0.2775343        -0.1766309        -0.2863690
4.z5   0.501            0.433             0.140               0.094
4.p   -0.055           -0.129            -0.263              -0.454
5.z1   1.412           -0.131             0.201              -0.014
5.z2   0.218918         0.191659         -0.3442095          -0.077372458
5.z3  -0.078           -0.039             0.25                0.151
5.z4  -0.03708266      -0.05991734       -0.218708158       0.2277081582
5.z5   0.565            0.05              0.383              -0.122
5.p   -1.269           -1.526            -1.876              -1.49
6.z1   0.715            0.017            -0.129              -0.026
6.z2   0.404091629      0.0590566        -0.384386418        -0.7887476
6.z3  -0.354           -0.141            -0.438              -0.385
6.z4   0.244853         0.29214695673    -0.2763856          -0.20061438
6.z5   0.52             0.889             0.317              -0.021
6.p   -0.365           -0.919            -1.483              -1.892
7.z1   1.745           -0.216            -0.536               0.005
7.z2   0.778813         0.6049471         0.5838983          -0.1736482
7.z3  -0.037            0.479             0.008               0.25
7.z4  -0.0201          -0.050912         -0.1547366           0.141736618
7.z5   0.872            0.327             0.106               0.289
7.p   -0.048           -0.159            -0.369              -0.469
;
variables
  x1        Length from Base to Force on Long Lever
  x2        Length from Force to Spring on Long Lever
  x3        Length from Base to Force on Short Lever
  x4        Length from Force to Joint on Short Lever
  x8        Length of Rack
  x9
  x12       Dial Diameter
  x13       Cover Length
  x14
  y(atb,i)  marketing variables: product att+price
  objM      marketing objective function
  objE      engineering objective function
;

binary variables
*auxilary binary variables for representing piecewise linear utility functions
z(atb,i)
;

equations
*objective functions
  MktObj              marketing objective
  EngObj              engineering objective
* auxilary constraints for peicewise linear functions
  conslo(atb,i), consup(atb,i,j)
* marketing bounding constraints
  explo(ns),expup(ns)
  demandlo(ns), demandup(ns)
*engineering constraints
  x5lo,x5up            bounds on x5
  wc1, wc2             weight capacity
  ar1,ar2              aspect ratio
  ns1,ns2              number size
  pa1,pa2              platform area
  tg1,tg2              tickmark gap
  cst1,cst2,cst3,cst4
  cst5,cst6,cst7,cst8
  cst9,cst10,cst11
  cst12,cst13,cst14

*branching constraints
branch1       z1>0.249
branch2       z3>0.985
branch3       z2<0.504
branch4       z4<0.49
 branch5       z5<0.690
 branch6       z5>0.702


;
* upper and lower bounds
y.lo(atb,i)=0.0; y.up(atb,i)=delx(atb,i);
x1.lo=0.125;     x1.up=12;
x2.lo=0.125;     x2.up=12;
x3.lo=0.125;     x3.up=12;
x4.lo=0.125;     x4.up=12;
x8.lo=2.00;      x8.up=10;
x9.lo=0.25;      x9.up=0.25;
x12.lo=4.0;      x12.up=12;
x13.lo=8.0;      x13.up=14;
x14.lo=8.0;      x14.up=14;

* starting point
xs1=1.845  ;
xs2=9.814  ;
xs3=0.824  ;
xs4=4.720  ;
xs8=4.273  ;
xs12=9.547  ;
xs13=11.747 ;
xs14=11.5 ;

* objective functions
MktObj ..   objM=e=Q*sum(ns,s(ns)*exp(sum(atb,f0(ns,atb)+sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i))))/
            (1+exp(sum(atb,f0(ns,atb)+sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i)))))*(20*sum(i,y('p',i))+10-cv))-cI
            -100*(sum(at,landa(at)*sum(i,y(at,i))))/5.0;
EngObj .. objE=e=(landa('z1')*(2*pi*x6*x9*x10*(x1+x2)/(x11*x1)-100*MinzE('z1'))/(MaxzE('z1')-MinzE('z1'))
                 +landa('z2')*100*(x13/x14-MinzE('z2'))/(MaxzE('z2')-MinzE('z2'))
                 +landa('z3')*(x13*x14-100*MinzE('z3'))/(MaxzE('z3')-MinzE('z3'))
                 +landa('z4')*100*(x12*x11*x1/(.2*x6*x9*x10*(x1+x2))-MinzE('z4'))/(MaxzE('z4')-MinzE('z4'))
                 +landa('z5')*100*(2*(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2))+(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2)))**3/3
                  )*(.5*x12-y12)
                 /(1+2/y3*(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2))+(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2)))**3/3
                 ))-MinzE('z5'))/(MaxzE('z5')-MinzE('z5'))
                 )/5.0;
* auxilary constraints for representing peicewise linear functions
conslo(atb,i)$(ord(i)<4) .. y(atb,i)=g=delx(atb,i)*z(atb,i);
consup(atb,ij(j,i)).. y(atb,i)=l=delx(atb,i)*z(atb,j);

* marketing bounding constraints
explo(ns) .. exp(sum(atb,f0(ns,atb)+sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i))))=g=exp(sum(atb,minz(ns,atb)));
expup(ns) .. exp(sum(atb,f0(ns,atb)+sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i))))=l=exp(sum(atb,maxz(ns,atb)));

demandlo(ns) ..  exp(sum(atb,f0(ns,atb)+sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i))))/(1+exp(sum(atb,f0(ns,atb)+
                 sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i)))))=g=exp(sum(atb,minz(ns,atb)))/(1+exp(sum(atb,minz(ns,atb))));
demandup(ns) ..  exp(sum(atb,f0(ns,atb)+sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i))))/(1+exp(sum(atb,f0(ns,atb)+
                 sum(i,dely(ns,atb,i)/delx(atb,i)*y(atb,i)))))=l=exp(sum(atb,maxz(ns,atb)))/(1+exp(sum(atb,maxz(ns,atb))));

* engineering constraints

* weight capacity bounds
wc1  ..(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)-MinzE('z1'))/(MaxzE('z1')-MinzE('z1'))=g=.251;
wc2  ..(0.02*pi*x6*x9*x10*(x1+x2)/(x11*x1)-MinzE('z1'))/(MaxzE('z1')-MinzE('z1'))=l=1.0;
*aspect ratio bounds
ar1 .. (x13/x14-MinzE('z2'))/(MaxzE('z2')-MinzE('z2'))=l=0.501;
ar2 .. (x13/x14-MinzE('z2'))/(MaxzE('z2')-MinzE('z2'))=g=0.0;
*platform area bounds

pa1 .. (0.01*x13*x14-MinzE('z3'))/(MaxzE('z3')-MinzE('z3'))=l=1.0;
pa2 .. (0.01*x13*x14-MinzE('z3'))/(MaxzE('z3')-MinzE('z3'))=g=0.985;

*tickmark gap bounds
tg1 .. (10*x12*x11*x1/(2*x6*x9*x10*(x1+x2))-MinzE('z4'))/(MaxzE('z4')-MinzE('z4'))=l=0.49;
tg2 .. (10*x12*x11*x1/(2*x6*x9*x10*(x1+x2))-MinzE('z4'))/(MaxzE('z4')-MinzE('z4'))=g=0.0;
*number size bounds
ns1 .. (2*(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2))+(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2)))**3/3
       )*(.5*x12-y12)/(1+2/y3*(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2))+(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2)))**3/3))
       -MinzE('z5'))/(MaxzE('z5')-MinzE('z5'))=l=.6835;
ns2 .. (2*(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2))+(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2)))**3/3
       )*(.5*x12-y12)/(1+2/y3*(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2))+(pi*y8*x11*x1/(2*pi*x6*x9*x10*(x1+x2)))**3/3))
       -MinzE('z5'))/(MaxzE('z5')-MinzE('z5'))=g=0.6815;

* bounds on x5
x5lo .. x1*x4=g=x3*x5min;
x5up .. x1*x4=l=x3*x5max;

* dial should fit within the scale
cst1 .. x12=l=x14-2*y1;
cst2 .. x12=l=x13-2*y1-x7-y2;
* long levers should fit within the scale
cst3 .. x1+x2=l=sqrt(power(x13-2*y1-x7,2)+power(.5*x14-y1,2));
cst4 .. x1+x2=g=sqrt(power(x13-2*y1-x7,2)+((x1+x2)*y7/x2)**2);
* joint position of short and long levers
cst5 .. x1*x4=l=x2*x3;
* scale stability
cst6 .. (x2*x3-x1*x4)/(x3*(x1+x2))*sqrt((x1+x2)**2-power(x13-2*y1-x7,2))+x4*sqrt(1-power(((x2-x1*x4/x3)/(x1+x2)*(x13-2*y1-x7)+x7)/(x3+x4),2))=g=y7;
cst7 .. (x13-2*y1)*(x1+x2)*(x3+x4)-x3*(x1+x2)*(x13-2*y1-x7)-x3*x7*(x1+x2)=g=y13*(x1+x2)*(x3+x4);
* short levers should fit within the scale
cst8 ..  x3+x4=l=sqrt(power(x2-x1*x4/x3,2)+(x7**2+power(.5*x14-y1,2))-2*(x2-x1*x4/x3)*sqrt(x7**2+power(.5*x14-y1,2))*(sqrt(1-power
         (x7/sqrt(power(.5*x14-y1,2)+x7**2),2))*sqrt(1-power((x13-2*y1-x7)/(x1+x2),2))-(x7/sqrt(power(.5*x14-y1,2)+x7**2))*(x13-2*y1-x7)/(x1+x2)));
cst9 .. x3+x4=g=(x2-x1*x4/x3)/(x1+x2)*(x13-2*y1-x7)+x7;
* rack must fit within the scale
cst10 .. x8+x7+y2+x11=l=x13-2*y1;
cst11..  x8=g=x13-2*y1-.5*x12-x7-y2-x10;
* spring deflection
cst12.. y6=g=2*pi*x9*x10/x11;
* dial should not intefere with support positions on levers
cst13.. 0.5*x12=l=sqrt(power(x13-2*y1-.5*x12-x7,2)+x2**2-2*(x13-2*y1-.5*x12-x7)*x2*(x13-2*y1-x7)/(x1+x2));
cst14.. 0.5*x12=l=sqrt(power((x2-x1*x4/x3)/(x1+x2)*sqrt((x1+x2)**2-power(x13-2*y1-x7,2))+x4*sqrt(1-power((((x2-x1*x4/x3)/(x1
        +x2)*(x13-2*y1-x7)+x7)/(x3+x4)),2)),2)+power(x13-2*y1-0.5*x12-x3*(((x2-x1*x4/x3)/(x1+x2)*(x13-2*y1-x7)+x7)/(x3+x4)),2));

*branching constraints
branch1 ..   sum(i,y('z1',i))=g=0.251;
branch2 ..   sum(i,y('z3',i))=g=0.985;
branch3 ..   sum(i,y('z2',i))=l=0.501;
branch4 ..   sum(i,y('z4',i))=l=0.49;
branch5 ..   sum(i,y('z5',i))=l=0.6835;
branch6 ..   sum(i,y('z5',i))=g=0.6815;



model MKTpb /MktObj,conslo, consup,explo,expup,demandlo, demandup,branch1,branch2,branch3,branch4,branch5,branch6/
model ENGpb /EngObj,x5lo,x5up,wc1, wc2,ar1,ar2,ns1,ns2,pa1,pa2,tg1,tg2,cst1,cst2,cst3,cst4,cst5,cst6,cst7,cst8,cst9,cst10,cst11,cst12,cst13,cst14/

option minlp=baron;
option nlp=baron;

MKTpb.optfile=1;
ENGpb.optfile=1;

$onecho > baron.opt
    explo.equclass=1
    expup.equclass=1
    demandlo.equclass=1
    demandup.equclass=1
    epsr=0.001
    maxtime=1200000
    nlpsol=4
    pfreq=500
    brptstra=2
$offecho

landa(at)=0.0;   x1.l=xs1;
   x2.l=xs2;
   x3.l=xs3;
   x4.l=xs4;
   x8.l=xs8;
   x12.l=xs12;
   x13.l=xs13;
   x14.l=xs14;
*lagrangian decomposition - subgradient method
loop (ii,
* updating alpha acording to the diminishing step size rule
   alpha=15/(0.2*ord(ii)+1);
* setting the starting point

* solving the marketing sub-problem
   solve Mktpb using minlp maximizing objM;
   zM(atb)=sum(i,y.l(atb,i));
*   landa(at)=landa(at)+alpha*zM(at);

* solving the engineering subproblem
   solve Engpb using nlp maximizing objE;

   zE('z1')=(0.02*pi*x6*x9.l*x10*(x1.l+x2.l)/(x11*x1.l)-MinzE('z1'))/(MaxzE('z1')-MinzE('z1'));
   zE('z2')=(x13.l/x14.l-MinzE('z2'))/(MaxzE('z2')-MinzE('z2'));
   zE('z3')=(0.01*x13.l*x14.l-MinzE('z3'))/(MaxzE('z3')-MinzE('z3'));
   zE('z4')=(10*x12.l*x11*x1.l/(2.0*x6*x9.l*x10*(x1.l+x2.l))-MinzE('z4'))/(MaxzE('z4')-MinzE('z4'));
   zE('z5')=(2*(pi*y8*x11*x1.l/(2*pi*x6*x9.l*x10*(x1.l+x2.l))+(pi*y8*x11*x1.l/(2*pi*x6*x9.l*x10*(x1.l+x2.l)))**3/3+
             2*(pi*y8*x11*x1.l/(2*pi*x6*x9.l*x10*(x1.l+x2.l)))**5/15)*(.5*x12.l-y12)
             /(1+2/y3*(pi*y8*x11*x1.l/(2*pi*x6*x9.l*x10*(x1.l+x2.l))+(pi*y8*x11*x1.l/(2*pi*x6*x9.l*x10*(x1.l+x2.l)))**3/3+
             2*(pi*y8*x11*x1.l/(2*pi*x6*x9.l*x10*(x1.l+x2.l)))**5/15))-MinzE('z5'))/(MaxzE('z5')-MinzE('z5'));

   TotObj(ii)=objM.l+objE.l;

*   landa(at)=landa(at)-alpha*zE(at);


* updating the lagrange multipliers according to ordinary sub-gradient method
   landa(at)=landa(at)-alpha*(zE(at)-zM(at));
   display zM,zE,landa,TotObj;

);
